<template>
    <v-dialog v-model="dialog" persistent max-width="600px">
        <template v-slot:activator="{ on }">
            <v-icon
                small
                v-on="on"
            >
                device_hub
            </v-icon>
        </template>
        <v-card>
            <v-card-title>
                <span class="headline">Roles</span>
            </v-card-title>
            <v-card-text>
                <v-container grid-list-md>
                    <v-layout wrap>
                        <v-flex xs12 sm12>
                            <v-autocomplete
                                :items="roles"
                                v-model="selected"
                                label="Roles"
                                item-text="name"
                                item-value="name"
                                multiple
                            ></v-autocomplete>
                        </v-flex>
                    </v-layout>
                </v-container>
                <small>*roles required</small>
            </v-card-text>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" flat @click="dialog = false">Close</v-btn>
                <v-btn color="blue darken-1" flat @click="save">Save</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>

<script>
    import helpers from './../../helpers';
    export default {
        name: "Roles",
        props:{
          userId: {
              type: Number
          }
        },
        data() {
            return {
                dialog: false,
                roles: [],
                selected: []
            }
        },
        created() {

        },
        watch: {
            dialog() {
                if (!this.dialog) {
                    this.roles = [];
                    this.selected = [];
                    return;
                }
                axios.get('panel/role').then(response => {
                    this.roles = response.data.data;
                }).catch(error => helpers.errorHandler(error));
                axios.get('panel/user/roles/' + this.userId).then(response => {
                    this.selected = response.data;
                }).catch(error => helpers.errorHandler(error));
            }
        },
        methods: {
            save() {
                axios.put('panel/user-roles/' + this.userId, {
                    roles: this.selected
                }).then(response => {
                    this.dialog = false
                }).catch(error => helpers.errorHandler(error));
            }
        }
    }
</script>

<style scoped>

</style>
